# redux-persist-transform-encrypt

[![npm](https://img.shields.io/npm/v/redux-persist-transform-encrypt.svg?maxAge=3600&style=flat-square)](https://www.npmjs.com/package/redux-persist-transform-encrypt)
[![Travis](https://img.shields.io/travis/maxdeviant/redux-persist-transform-encrypt.svg?maxAge=3600&style=flat-square)]()

Encrypt your Redux store.

## Usage

### Synchronous

```js
import createEncryptor from 'redux-persist-transform-encrypt';

const encryptor = createEncryptor({
  secretKey: 'my-super-secret-key'
});

persistStore(store, {
  transforms: [
    encryptor
  ]
});
```

### Asynchronous

**Note:** Asynchronous support is still a work in progress.

```js
import createAsyncEncryptor from 'redux-persist-transform-encrypt/async';

const asyncEncryptor = createAsyncEncryptor({
  secretKey: 'my-super-secret-key'
});

persistStore(store, {
  transforms: [
    asyncEncryptor
  ]
});
```
